import time
import socket
from zeroconf import *
import argparse

deviceList = []

class DNSListener:
    def remove_service(self, zeroconf, type, name):
        pass

    def add_service(self, zeroconf, type, name):
        info = zeroconf.get_service_info(type, name)
        deviceList.append(info)

def main():
    parser = argparse.ArgumentParser(description="Cast URL to a listening SimpleCast engine.")
    parser.add_argument("URLs", metavar="URL", type=str, nargs="+", help="URLs to be cast to SimpleCast engine.")
    parser.add_argument("--device", metavar="d", dest="device_name", help="DDNS Device name to use instead of prompting.")
    args = parser.parse_args()

    zconf = Zeroconf()
    dList = DNSListener()
    browser = ServiceBrowser(zconf, "_simplecast._tcp.local.", dList)


    print("Waiting to hear back from network...")

    if args.device_name != None:
        #TODO
        print("Unsupported argument. Needs implementation.")
        #firstdevice = {server:None}
        #while deviceList[0].server != args.device_name:
            #if(len(deviceList) > 0):
                #deviceList.pop(0)
            #time.sleep(1)
    else:
        while len(deviceList) < 1:
            time.sleep(1)
        print("Found => "+deviceList[0].name+" "+socket.inet_ntoa(deviceList[0].addresses[0])+":"+str(deviceList[0].port))
        cast_socket = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
        cast_socket.connect((socket.inet_ntoa(deviceList[0].addresses[0]), deviceList[0].port))
        for url in args.URLs:
            cast_socket.send(("SIMPLECAST|addURLToPlaylist|"+url).encode())
        cast_socket.close()
        print("Finished")


if __name__ == '__main__':
    main()